#include "config.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

#include <badpenguin-fs.h>
#include "../lib/gringo.h"
#include "main.h"
#include "options.h"
#include "dump.h"


#define IBUFFER_SIZE		80
#define LBUFFER_SIZE		40

int iRunning = 1;
int win_x, win_y, win_w, win_h;
int cx, cy;
int step=1;

TWindow *pWin = NULL;
TButton *pBtn = NULL;
TListBox *pList = NULL;


void fnQuit() {
	if (iRunning!=1) return;
	iRunning = 0;
	gringo_Terminate(0);
}

void checkwin() {
	if ((step==2)&&(pWin==NULL)) {
		perror("finestra non definita con --title !");
		fnQuit();
	}
}


#ifdef PIPPO
	  edit1 = edit_Create( currWin, stoken.x, stoken.y, stoken.w, stoken.ibuffer );
          object_SetName( TOBJECT(edit1), stoken.lname );

	  button1 = button_Create( currWin, stoken.x, stoken.y, stoken.w, stoken.ibuffer );
          object_SetName( TOBJECT(button1), stoken.lname );

	  check1 = checkbox_Create( currWin, stoken.x, stoken.y, stoken.ibuffer, stoken.w );
          object_SetName( TOBJECT(check1), stoken.lname );

	  currList = listbox_Create( currWin, stoken.x, stoken.y, stoken.w, stoken.h );
          object_SetName( TOBJECT(currList), stoken.lname );
          listbox_OnClick( currList, gringosh_dump );

	  currGrid = grid_Create( currWin, stoken.x, stoken.y, stoken.w, stoken.h );
          object_SetName( TOBJECT(currGrid), stoken.lname );
          grid_OnClick( currGrid, gringosh_dump );

          listbox_AddItem( currList, stoken.ibuffer );

          window_BackTitle( currWin, stoken.ibuffer );
#endif


void ParseSourceFile() {
#define RBUFFER_SIZE		4096
#define SEPARATORS		" \t|"
	char readbuffer[RBUFFER_SIZE];
	char *token;
	char *linebuffer;
	int pmode;
	int l;
	unsigned char *p1 = NULL;
	char buffer[256];
	FILE *fd = NULL;


	/* Inizializza variabili utilizzate per il parsing */
	win_x=0;
	win_y=2;
	win_w=COLS-3;
	win_h=LINES-5;
	win_h=0;

parseagain:
	cx=0;
	cy=1;
	if (verbose<=1) printf("- parsing source file \n");
nextline:
	readbuffer[0]=0;
	pmode=0;
	while ( ! feof(source_file) ) {
		read_line( source_file, readbuffer );
		linebuffer = strdup(readbuffer);	
		if (verbose<=0) printf("- linebuffer: %s \n", linebuffer );

		token = strtok( linebuffer, SEPARATORS );
		if (verbose<=0) printf("-      token: [%s] \n", token );

		// discard comment
		if (token==NULL) continue;
		if (token[0]=='#') continue;

		//  il primo token
		pmode=0;

		while (token!=NULL) {
			switch (pmode) {
				case 0: {
					if ( strcasecmp("--width", token) == 0 ) {
						pmode=1;
						break;
					}
					if ( strcasecmp("--height", token) == 0 ) {
						pmode=2;
						break;
					}
					if ( strcasecmp("--cwindow", token) == 0 ) {
						if (step==1) goto nextline;
						pmode=3;
						break;
					}
					if ( strcasecmp("--rlabel", token) == 0 ) {
						pmode=4;
						break;
					}
					if ( strcasecmp("--clabel", token) == 0 ) {
						pmode=5;
						break;
					}
					if ( strcasecmp("--rbutton", token) == 0 ) {
						if (step==1) goto nextline;
						pmode=6;
						break;
					}
					if ( strcasecmp("--cbutton", token) == 0 ) {
						if (step==1) goto nextline;
						pmode=7;
						break;
					}
					if ( strcasecmp("--lbutton", token) == 0 ) {
						if (step==1) goto nextline;
						pmode=8;
						break;
					}
					if ( strcasecmp("--listbox", token) == 0 ) {
						pmode=9;
					break;
					}
					if ( strcasecmp("--listitem", token) == 0 ) {
						if (step==1) goto nextline;
						pmode=10;
						break;
					}
					if ( strcasecmp("--addfile", token) == 0 ) {
						if (step==1) goto nextline;
						pmode=11;
						break;
					}
					if ( strcasecmp("--backtitle", token) == 0 ) {
						if (step==1) goto nextline;
						pmode=12;
						break;
					}
					if ( strcasecmp("--lowertitle", token) == 0 ) {
						if (step==1) goto nextline;
						pmode=13;
						break;
					}
					if ( strcasecmp("--newline", token) == 0 ) {
						cy++;
						break;
					}
					if ( strcasecmp("--quit", token) == 0 ) {
						if (step==1) goto finalcheck;
						gringo_Paint();
						refresh();
						gringo_Quit();
						exit(0);
					}
					printf ("Comando sconosciuto: %s \n", token );
					token=NULL;
					break;
				}
				// --width larghezza finestra
				case 1: {
					win_w = atoi(token);
					win_x = ( COLS - win_w ) / 2;
					pmode=0; token=NULL; continue;
				}
				// --height altezza finestra
				case 2: {
					win_h = atoi(token);
					win_y = ( LINES - win_h ) / 2;
					pmode=0; token=NULL; continue;
				}
				// --cwindow
				case 3: {
					p1 = strstr( readbuffer, token );
					pWin = window_Create( win_x, win_y, win_w, win_h, p1 );
					window_OnClose( pWin, fnQuit );
					pmode=0; token=NULL; continue;
				}
				// rlabel
				case 4:
				case 5: {
					checkwin();

					// create a buffer with the token
					p1 = strstr( readbuffer, token );
					strcpy( linebuffer, p1 );
					p1 = linebuffer;

					l = win_w-2;
					cx = 1;
					while ( strlen(p1) > l ) {
						strncpy( buffer, p1, l );
						buffer[l]=0;
						if (pmode==5) cx = (win_w - l) / 2;
						if (step==2) label_Create( pWin, cx, cy, l, buffer );
						cy++; 		// avanza riga
						p1 += l; 	// avanza puntatore
					}
					if (pmode==5) cx = (win_w - strlen(p1)) / 2;
					if (step==2) label_Create( pWin, cx, cy, strlen(p1), p1 );
					pmode=0; token=NULL; continue;
				}

				// rbutton, cbutton, lbutton
				case 6:
				case 7:
				case 8: {
					checkwin();
					p1 = strstr( readbuffer, token );
					l = strlen(p1);
					if (pmode==6) {
						cx = 1;
					} else
					if (pmode==7) {
						cx = (win_w - l) /2;
					} else {
						cx = win_w - l - 3;
					}
					pBtn = button_Create( pWin, cx, cy, l, p1 );
					button_OnClick( pBtn, fnQuit );
					pmode=0; token=NULL; continue;
				}
				// list box
				case 9: {
					checkwin();  
					l = atoi(token);
					if (step==2) {
						pList = listbox_Create( pWin, 1, cy, win_w-2, l );
						listbox_OnClick( pList, fnQuit );
					}
					cy += l;
					pmode=0; token=NULL; continue;
				}
				case 10: {
					checkwin();
					assert(pList!=NULL);
					p1 = strstr( readbuffer, token );
					assert(p1!=NULL);
					listbox_AddItem( pList, p1 );
					pmode=0; token=NULL; continue;
				}
				case 11: {
					checkwin();
					fd = fopen( token, "r");
					if (fd==NULL) break;
					while (!feof(fd)) {
						fgets(buffer,256,fd);
						listbox_AddItem( pList, buffer );
					}
					fclose(fd);
					pmode=0; token=NULL; continue;
				}
				// back title
				case 12: {
					p1 = strstr( readbuffer, token );
					pWin->backtitle = strdup(p1);
					pmode=0; token=NULL; continue;
				}
				// lower title
				case 13: {
					p1 = strstr( readbuffer, token );
					pWin->lowertitle = strdup(p1);
					pmode=0; token=NULL; continue;
				}
				default: {
					pmode=0;
					gringo_Quit();
					printf ("Parametro errato: %s \n", token );
					exit(1);
					break;
				}
			} // end switch

			// token
			token = strtok( NULL, SEPARATORS );
			if (verbose<=0) printf("- next token: [%s] \n", token );
		}
	}				
		
	// resize win
finalcheck:
	cy++;
	// resizewin(); ...
	if (cy>win_h) {
		printf("> aumento altezza finestra da %i a %i \n", win_h, cy );
		win_h = cy;
		win_y = ( LINES - win_h ) / 2;
	}
	if (step==1) {
		step++;
		fseek(source_file,0,SEEK_SET);
		goto parseagain;
	}
}
